using namespace CS225;

template<typename T>
CursorList<T>::CursorList(void) : ObjectList<T>()
{
	Reset();
}

template<typename T>
CursorList<T>::CursorList(const CursorList<T> &rhs) : ObjectList<T>(static_cast<const ObjectList<T>&>(rhs))
{
	Reset();
}

template<typename T>
CursorList<T> & CursorList<T>::operator=(const CursorList<T> &rhs)
{
	if(&rhs==this)
		return *this;
	Reset();
	while(!this->empty())
	{
		Next();
		Remove();
	}
	rhs.Reset();
	Reset();
	while(ObjectList<T>::size()!=rhs.size())
	{
		Next();
		rhs.Next();
		Insert(rhs.Get());
	}
	rhs.Reset();
	Reset();
	return *this;
}

template<typename T>
CursorList<T>::~CursorList()
{}

template<typename T>
void CursorList<T>::Reset(void) const
{	
	typename ObjectList<T>::Node ***p = const_cast<typename ObjectList<T>::Node***>(&cursor_);  //reset
	*p=const_cast<typename ObjectList<T>::Node**>(ObjectList<T>::PtrToHead());
	*const_cast<typename ObjectList<T>::Node***>(&prev_)=NULL;
}

template<typename T>
bool CursorList<T>::Next(void) const
{
	if((*cursor_)==NULL)  //check for end
		return false;
	else
	{
		typename ObjectList<T>::Node *f =*cursor_;
		*const_cast<typename ObjectList<T>::Node***>(&prev_)=*const_cast<typename ObjectList<T>::Node***>(&cursor_);
		*const_cast<typename ObjectList<T>::Node***>(&cursor_)=reinterpret_cast<typename ObjectList<T>::Node**>(f);  //move cursor
		return true;
	}
}

template<typename T>
void CursorList<T>::Insert(const T& value)
{ObjectList<T>::insert(const_cast<typename ObjectList<T>::Node**>(cursor_), value);}  //call ObjectList insert with cursor and value

template<typename T>
void CursorList<T>::Remove(void)
{ObjectList<T>::remove(const_cast<typename ObjectList<T>::Node**>(cursor_));}  //call ObjectList remove with cursor

template<typename T>
const T& CursorList<T>::Get(void) const
{
	//if(prev_&&(*prev_))
		return (*prev_)->data_;
	/*else
	{
		const int& x=-999;
		return x;
	}*/
}

template<typename T>
T& CursorList<T>::Get(void)
{
	//if(prev_&&(*prev_))
		return (*prev_)->data_;
	/*else
	{
		int *x = new int;
		*x=-999;
		return *x;
	}*/

}
