#ifndef CURSORLIST_H
#define CURSORLIST_H

#include "ObjectList.h"

namespace CS225
{
	template<typename T>
	class CursorList : public ObjectList<T>
	{
		public:
			CursorList(void);
			CursorList(const CursorList &rhs);
			CursorList & operator=(const CursorList &rhs);
			virtual ~CursorList();
			void Reset(void) const;
			bool Next(void) const;
			void Insert(const T& value);
			void Remove(void);
			const T& Get(void) const;
			T& Get(void);

		private:
			typename ObjectList<T>::Node *const *cursor_;
			typename ObjectList<T>::Node *const *prev_;
	};
}

#include "CursorList.cpp"
#endif
