#include "SubscriptError.h"

using namespace CS225;

template<typename T>
IndexedList<T>::IndexedList(void):CursorList<T>() {}

template<typename T>
IndexedList<T>::IndexedList(const IndexedList<T> &rhs) : CursorList<T>(static_cast<const CursorList<T>&>(rhs)){}

template<typename T>
IndexedList<T>::~IndexedList(void) {}

template<typename T>
const T& IndexedList<T>::operator[](int index) const
{
	if(index>=static_cast<int>(ObjectList<T>::size()))
	{
		SubscriptError e(index, "Invalid Index");
		throw(e);
	}
	else
	{
		CursorList<T>::Reset();
		for(int i=0;i<=index;i++)
			CursorList<T>::Next();
		return CursorList<T>::Get();
	}
}

template<typename T>
T& IndexedList<T>::operator[](int index)
{
	if(index>=static_cast<int>(ObjectList<T>::size()))
	{
		SubscriptError e(index, "Invalid Index");
		throw(e);
	}
	else
	{
		CursorList<T>::Reset();
		for(int i=0;i<=index;i++)
			CursorList<T>::Next();
		return CursorList<T>::Get();
	}
}
