using namespace CS225;

template<typename T>
ObjectList<T>::ObjectList(void)
{head_=NULL, tail_=&head_, size_=0;}

template<typename T>
ObjectList<T>::ObjectList(const ObjectList<T> &rhs)
{
	if(&rhs==this) //check for self assignment
		return;
	else if(rhs.empty())
	{head_=NULL, tail_=&head_, size_=0;}  //basic assignment
	else
	{
		size_=0;
		typename ObjectList<T>::Node *hp = const_cast<typename ObjectList<T>::Node*>(*rhs.PtrToHead());  //generate cursor pointer
		if(hp)
		{
			typename ObjectList<T>::Node * first = new typename ObjectList<T>::Node(hp->data_);  //generate first node
			head_=first;  //assign head
			tail_=&(head_->next_);  //assign tail
			hp=hp->next_;  //move cursor
			size_++;
			while(hp)  //while there are nodes remaining:
			{
				push_back(hp->data_);  //push back new node
				hp=hp->next_;  //move cursor
			}
		}
	}
}

template<typename T>
ObjectList<T> & ObjectList<T>::operator=(const ObjectList<T> &rhs)
{
	if(&rhs==this) //check for self assignment
		return *this;
	else if(rhs.empty())
	{
		head_=NULL, *tail_=head_, size_=0;
		return *this;
	}
	else
	{
		clear();  //empty list
		size_=0;
		typename ObjectList<T>::Node *hp = const_cast<typename ObjectList<T>::Node*>(*rhs.PtrToHead());  //generate cursor pointer
		if(hp)
		{
			typename ObjectList<T>::Node * first = new typename ObjectList<T>::Node(hp->data_);  //generate first node
			head_=first;  //assign head
			tail_=&(head_->next_);  //assign tail
			hp=hp->next_;  //move cursor
			size_++;
			while(hp)  //while there are nodes remaining:
			{
				push_back(hp->data_);  //push back new node
				hp=hp->next_;  //move cursor
			}
		}
		return *this;
	}
}

template<typename T>
ObjectList<T>::~ObjectList()
{clear();}  //clear list

template<typename T>
void ObjectList<T>::push_back(const T& item) throw(std::bad_alloc)
{
	typename ObjectList<T>::Node *newNode = new typename ObjectList<T>::Node(item);  //new node
	(*tail_)=newNode;   //set next of the previous node
	tail_=&(newNode->next_);   //set tail ptr
	size_++;  //inc size
}

template<typename T>
void ObjectList<T>::pop_front(void)
{
	if(head_)  //if there is >0 node
	{
		typename ObjectList<T>::Node *removed = head_;  //get ptr to node
		head_ = head_->next_;  //reassign head
		delete removed;  //delete node
		size_--;  //dec size
	}
}

template<typename T>
unsigned ObjectList<T>::size(void) const
{return size_;}

template<typename T>
bool ObjectList<T>::empty(void) const
{
	if(size_>0)
		return false;
	else
		return true;
}

template<typename T>
typename ObjectList<T>::Node * const *ObjectList<T>::PtrToHead(void) const
{
	return static_cast<typename ObjectList<T>::Node*const*>(&head_);
}

template<typename T>
void ObjectList<T>::remove(typename ObjectList<T>::Node **pptr)
{
	if(*pptr!=NULL)  //if there is a node to be removed
	{
		typename ObjectList<T>::Node *removed = *pptr;  //get ptr to node to be removed
		if((*pptr)->next_==*tail_)  //deal with tail case
		 tail_ = pptr;
		*pptr = (*pptr)->next_;  //deal with surrounding ptrs
		delete removed;  //delet node
		size_--;  
	}
}

template<typename T>
void ObjectList<T>::insert(typename ObjectList<T>::Node **pptr, const T& value)
{
	typename ObjectList<T>::Node *newNode = new typename ObjectList<T>::Node(value);  //generate a new node
	newNode->next_= (*pptr);  //set next
	if(pptr==tail_)  //handle tail case
		tail_=&(newNode->next_);
	*pptr = newNode;  //set previous nodes next
	size_++;
}

template<typename T>
void ObjectList<T>::clear(void)
{
	while(size_>0)
		pop_front();
}

template<typename T>
void ObjectList<T>::copy(const ObjectList<T> &rhs)
{
	*this = rhs;
}

template<typename T>
void ObjectList<T>::reset_tail(void)
{tail_=&head_;}
