#ifndef OBJECTLIST_H
#define OBJECTLIST_H

#ifdef _MSC_VER
#pragma warning(disable: 4290) // Suppress 'C++ Exception Specification ignored'
#endif

#include <new> // std::bad_alloc

namespace CS225
{

template<typename T>
class ObjectList
{
  public:
    ObjectList(void);
    ObjectList(const ObjectList &rhs);
    ObjectList & operator=(const ObjectList &rhs);
    virtual ~ObjectList();
    void push_back(const T& item) throw(std::bad_alloc);
    void pop_front(void);
    unsigned size(void) const;
    bool empty(void) const;

    struct Node
    {
      Node(const T& item) : next_(0), data_(item) {}
      Node *next_;
      T data_;
    };
    Node * const *PtrToHead(void) const;

  protected:
    void remove(Node **pptr);
    void insert(Node **pptr, const T& value);
    
  private:
    void clear(void);
    void copy(const ObjectList &rhs);
	void reset_tail(void);
    Node *head_;
    Node **tail_;
    unsigned size_;
};

} // namespace CS225

#include "ObjectList.cpp"

#endif // OBJECTLIST_H
